/*
 * citygml4j - The Open Source Java API for CityGML
 * https://github.com/citygml4j
 *
 * Copyright 2013-2019 Claus Nagel <claus.nagel@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.citygml4j.builder.cityjson.extension;

import org.citygml4j.cityjson.extension.Extension;

import java.util.Objects;

public class ExtensionProperty implements Extension {
    private final String name;
    private final Object value;

    public ExtensionProperty(String name, Object value) {
        this.name = Objects.requireNonNull(name, "name must not be null.");
        this.value = Objects.requireNonNull(value, "value must not be null.");
    }

    public String getName() {
        return name;
    }

    public Object getValue() {
        return value;
    }
}
